#include <winsock2.h>		//tem que ser definido antes de windows
#include <windows.h>
#include <stdio.h>

#ifndef INCLUDEUCHAR
#ifndef uchar
#define uchar unsigned char
#define uint unsigned int
#define ulong unsigned long
#define ushort  unsigned short
#endif
#endif
////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
//inclusao de haders locais direto

#include "folder.h"
#include "dprintf.h"

////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

// Funcoes externas

// entram por header
// assim evita problemas mais tarde
// ma pode gerar erros depois


////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

// Definicao de variaveis

static int already_running = 0;

static int messagewindow = 0;	//hwnd do window  que vai receber a mensagem

static int net_error = 0;	// error de winsock

static char int_err_str[300];	// error status string


static char *intproto = NULL;
static char *inturl = NULL;
static char *intpath = NULL;
static char *intfile = NULL;
static char *intuser = NULL;
static char *intpassword = NULL;
static char *intport = NULL;

static int is_http = 0;


static int ishttp (char *url);
////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

//Definicao de funcoes exportaveis

char *getnetstatus (int *value);

int set_sendmessage_nwnd (int value);

int debug_rede ();

/*vai ser exportada para ficar mais facil*/
int isurl (char *url);

////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
//Definicao de funcoes nao exportaveis

static void url_encode (char **url);


static void print_net_error (int errorcode);

static int rspsendmessage ();

static int setmessage (int val, char *text);

static int isalive ();

static int parseurl (char *url);

static int initwinsock (int mode);

////////////////////////////////////////////////////////////////////////////////////////

//funcoes geradas com Zg
static int __cdecl initwinsock (int mode);
static void __cdecl print_net_error (int errorcode);
extern int __cdecl debug_rede (char *url);
static int __cdecl setmessage (int val, char *text);
static int __cdecl rspsendmessage ();
extern int __cdecl set_sendmessage_nwnd (int value);
extern char *__cdecl getnetstatus (int *value);
static int __cdecl isalive ();
extern int __cdecl isurl (char *url);
static int __cdecl ishttp (char *url);
static void __cdecl url_encode (char **url);
static int __cdecl parseurl (char *url);



////////////////////////////////////////////////////////////////////////////////////////

static int
initwinsock (int mode)
{

/*

0 para iniciar
1 para terminar

retorna 1 se der certo
e 0 se der errado

1/7/2005 8:51PM
Fim de desenvolvimento desta funcao
Esta pronta para emissao

*/
	WSADATA WsaData;
	static int init = 0;

	int ret = 0;

	net_error = 0;




	if (0 == mode)
	  {

		  if (1 == init)
		    {
			    //dprintf ("winsock already initialized \n");
			    return 1;
		    }
		  else
		    {


			    if ((ret = WSAStartup (0x101, &WsaData)) == 0)
			      {

				      //dprintf ("winsock started \n");

				      //dprintf (" version %d.%d\n", LOBYTE (WsaData.wVersion), HIBYTE (WsaData.wVersion));

				      init = 1;

				      return 1;
			      }
			    else
			      {

				      print_net_error (ret);

				      return 0;
			      }
		    }

	  }
	else
	  {
		  if (1 == init)
		    {

			    WSACancelBlockingCall ();

			    dprintf ("winsock deactivated \n");
			    ret = WSACleanup ();


			    // ret = SOCKET_ERROR;

			    if (ret == SOCKET_ERROR)
			      {

				      ret = WSAGetLastError ();
				      print_net_error (ret);
				      return 1;	// este caso  especial porque so vai ocorrer no fim
				      // e nunca sera chamado mesmo

			      }

			    /*aqui que eu estava */
			    init = 0;
			    return 1;

		    }
		  else
		    {

			    dprintf ("winsock was already unloaded \n");
			    return 1;

		    }
		  return 1;


	  }

	return 2;


}


////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////


//vai servir para uma outra classe de erros a serem listados depois
//static void
//print_net_error (int errorcode)
//{
///*funcao  interna e nao deve sair fora*/
//
//   // sprintf ( errstring,"valor de erro %d \n",net_error, errorcode);
//
///*
//
//1/7/2005 9:22PM
//terminou o desenvolvimento desta funcao tambem
//
//Pode procurar informacoes na internet referente ao uso destas rotinas
//
//Assim fica facil de localizar a informacao
//
//*/
//
//   static char errstring[300];
//
//   net_error = errorcode;
//
//
//   memset (errstring, 0, 300);
//
//
//
//   switch (errorcode)
//     {
//
//
//
//
//
//      case WSA_OPERATION_ABORTED:
//      sprintf (errstring, "WSA_OPERATION_ABORTED  ");
//      break;
//      case WSA_NOT_ENOUGH_MEMORY:
//      sprintf (errstring, "WSA_NOT_ENOUGH_MEMORY  ");
//      break;
//      case WSA_INVALID_PARAMETER:
//      sprintf (errstring, "WSA_INVALID_PARAMETER  ");
//      break;
//      case WSA_INVALID_HANDLE:
//      sprintf (errstring, "WSA_INVALID_HANDLE  ");
//      break;
//      case WSA_IO_INCOMPLETE:
//      sprintf (errstring, "WSA_IO_INCOMPLETE  ");
//      break;
//      case WSA_IO_PENDING:
//      sprintf (errstring, "WSA_IO_PENDING  ");
//      break;
//      case WSAEREFUSED:
//      sprintf (errstring, "WSAEREFUSED  ");
//      break;
//      case WSA_E_CANCELLED:
//      sprintf (errstring, "WSA_E_CANCELLED  ");
//      break;
//      case WSA_E_NO_MORE:
//      sprintf (errstring, "WSA_E_NO_MORE  ");
//      break;
//      case WSATYPE_NOT_FOUND:
//      sprintf (errstring, "WSATYPE_NOT_FOUND  ");
//      break;
//      case WSASERVICE_NOT_FOUND:
//      sprintf (errstring, "WSASERVICE_NOT_FOUND  ");
//      break;
//      case WSASYSCALLFAILURE:
//      sprintf (errstring, "WSASYSCALLFAILURE  ");
//      break;
//      case WSAEPROVIDERFAILEDINIT:
//      sprintf (errstring, "WSAEPROVIDERFAILEDINIT  ");
//      break;
//      case WSAEINVALIDPROVIDER:
//      sprintf (errstring, "WSAEINVALIDPROVIDER  ");
//      break;
//      case WSAEINVALIDPROCTABLE:
//      sprintf (errstring, "WSAEINVALIDPROCTABLE  ");
//      break;
//      case WSAECANCELLED:
//      sprintf (errstring, "WSAECANCELLED  ");
//      break;
//      case WSAENOMORE:
//      sprintf (errstring, "WSAENOMORE  ");
//      break;
//
//
//
//     case 0:
//      sprintf (errstring, "No error  ");
//      break;
//      //case WSA_OPERATION_ABORTED:
//      //sprintf (errstring, "WSA_OPERATION_ABORTED  ");
//
//     case WSAEDISCON:
//      sprintf (errstring, "Disconnect  ");
//      break;
//     case WSAEACCES:
//      sprintf (errstring, "Permission denied  ");
//      break;
//     case WSAEINTR:
//      sprintf (errstring, "Interrupted  ");
//      break;
//     case WSAEBADF:
//      sprintf (errstring, "Bad file number  ");
//      break;
//     case WSAEFAULT:
//      sprintf (errstring, "Bad address  ");
//      break;
//     case WSAEINVAL:
//      sprintf (errstring, "Invalid argument  ");
//      break;
//     case WSAEMFILE:
//      sprintf (errstring, "Too many open files  ");
//      break;
//     case WSAEWOULDBLOCK:
//      sprintf (errstring, "Operation would block  ");
//      break;
//     case WSAEINPROGRESS:
//      sprintf (errstring, "Blocking call in progress  ");
//      break;
//     case WSAEALREADY:
//      sprintf (errstring, "Operation already in progress  ");
//      break;
//     case WSAENOTSOCK:
//      sprintf (errstring, "Descriptor is not a socket  ");
//      break;
//     case WSAEDESTADDRREQ:
//      sprintf (errstring, "Destination address required  ");
//      break;
//     case WSAEMSGSIZE:
//      sprintf (errstring, "Data size too large  ");
//      break;
//     case WSAEPROTOTYPE:
//      sprintf (errstring,
//               "Protocol is of wrong type for this socket  ");
//      break;
//     case WSAENOPROTOOPT:
//      sprintf (errstring,
//               "Protocol option not supported for this socket type  ");
//      break;
//     case WSAEPROTONOSUPPORT:
//      sprintf (errstring, "Protocol is not supported  ");
//      break;
//     case WSAESOCKTNOSUPPORT:
//      sprintf (errstring,
//               "Socket type not supported by this address family  ");
//      break;
//     case WSAEOPNOTSUPP:
//      sprintf (errstring, "Option not supported  ");
//      break;
//     case WSAEPFNOSUPPORT:
//      sprintf (errstring, "Protocol family not supported  ");
//      break;
//     case WSAEAFNOSUPPORT:
//      sprintf (errstring,
//               "Address family not supported by this protocol  ");
//      break;
//     case WSAEADDRINUSE:
//      sprintf (errstring, "Address is in use  ");
//      break;
//     case WSAEADDRNOTAVAIL:
//      sprintf (errstring,
//               "Address not available from local machine  ");
//      break;
//     case WSAENETDOWN:
//      sprintf (errstring, "Network subsystem is down  ");
//      break;
//     case WSAENETUNREACH:
//      sprintf (errstring, "Network cannot be reached  ");
//      break;
//     case WSAENETRESET:
//      sprintf (errstring, "Connection has been dropped  ");
//      break;
//     case WSAECONNABORTED:
//      sprintf (errstring,
//               "The virtual circuit was terminated due to a time-out or other failure  ");
//      break;
//     case WSAECONNRESET:
//      sprintf (errstring,
//               "The virtual circuit was reset by the remote side  ");
//      break;
//     case WSAENOBUFS:
//      sprintf (errstring, "No buffer space available  ");
//      break;
//     case WSAEISCONN:
//      sprintf (errstring, "Socket is already connected  ");
//      break;
//     case WSAENOTCONN:
//      sprintf (errstring, "Socket is not connected  ");
//      break;
//     case WSAESHUTDOWN:
//      sprintf (errstring, "Socket has been shut down  ");
//      break;
//     case WSAETOOMANYREFS:
//      sprintf (errstring, "Too many references: cannot splice  ");
//      break;
//     case WSAETIMEDOUT:
//      sprintf (errstring, "Command timed out  ");
//      break;
//     case WSAECONNREFUSED:
//      sprintf (errstring, "Connection refused  ");
//      break;
//     case WSAELOOP:
//      sprintf (errstring, "Too many levels of symbolic links  ");
//      break;
//     case WSAENAMETOOLONG:
//      sprintf (errstring, "File name too long  ");
//      break;
//     case WSAEHOSTDOWN:
//      sprintf (errstring, "Host is down  ");
//      break;
//     case WSAEHOSTUNREACH:
//      sprintf (errstring, "No route to host  ");
//      break;
//     case WSAENOTEMPTY:
//      sprintf (errstring, "WSAENOTEMPTY  ");
//      break;
//     case WSAEPROCLIM:
//      sprintf (errstring, "Too many processes  ");
//      break;
//     case WSAEUSERS:
//      sprintf (errstring, "WSAEUSERS  ");
//      break;
//     case WSAEDQUOT:
//      sprintf (errstring, "WSAEDQUOT  ");
//      break;
//     case WSAESTALE:
//      sprintf (errstring, "WSAESTALE  ");
//      break;
//     case WSAEREMOTE:
//      sprintf (errstring, "WSAEREMOTE  ");
//      break;
//     case WSASYSNOTREADY:
//      sprintf (errstring, "Network subsystem not ready  ");
//      break;
//     case WSAVERNOTSUPPORTED:
//      sprintf (errstring, "Version not supported  ");
//      break;
//     case WSANOTINITIALISED:
//      sprintf (errstring,
//               "WSAStartup() has not been successfully called  ");
//      break;
//     case WSAHOST_NOT_FOUND:
//      sprintf (errstring, "Host not found  ");
//      break;
//     case WSATRY_AGAIN:
//      sprintf (errstring, "Host not found or SERVERFAIL  ");
//      break;
//     case WSANO_RECOVERY:
//      sprintf (errstring, "Non-recoverable error  ");
//      break;
//     case WSANO_DATA:
//      sprintf (errstring, "No data record of requested type  ");
//      break;
//     default:
//      sprintf (errstring, "Winsock error not listed !  ");
//      break;
//     }
//
//   strcpy (int_err_str, errstring);
//   return;
//
//}
//
//
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////

//vai servir para uma outra classe de erros a serem listados depois
//vai servir para uma outra classe de erros a serem listados depois
static void
print_net_error (int errorcode)
{
/*funcao  interna e nao deve sair fora*/

	// sprintf ( errstring,"valor de erro %d \n",net_error, errorcode);

/*

1/7/2005 9:22PM
terminou o desenvolvimento desta funcao tambem

Pode procurar informacoes na internet referente ao uso destas rotinas

Assim fica facil de localizar a informacao

*/

	static char errstring[300];

	net_error = errorcode;


	memset (errstring, 0, 300);



	switch (errorcode)
	  {





	  case WSA_OPERATION_ABORTED:
		  sprintf (errstring, "WSA_OPERATION_ABORTED  ");
		  break;
	  case WSA_NOT_ENOUGH_MEMORY:
		  sprintf (errstring, "WSA_NOT_ENOUGH_MEMORY  ");
		  break;
	  case WSA_INVALID_PARAMETER:
		  sprintf (errstring, "WSA_INVALID_PARAMETER  ");
		  break;
	  case WSA_INVALID_HANDLE:
		  sprintf (errstring, "WSA_INVALID_HANDLE  ");
		  break;
	  case WSA_IO_INCOMPLETE:
		  sprintf (errstring, "WSA_IO_INCOMPLETE  ");
		  break;
	  case WSA_IO_PENDING:
		  sprintf (errstring, "WSA_IO_PENDING  ");
		  break;
	  case WSAEREFUSED:
		  sprintf (errstring, "WSAEREFUSED  ");
		  break;
	  case WSA_E_CANCELLED:
		  sprintf (errstring, "WSA_E_CANCELLED  ");
		  break;
	  case WSA_E_NO_MORE:
		  sprintf (errstring, "WSA_E_NO_MORE  ");
		  break;
	  case WSATYPE_NOT_FOUND:
		  sprintf (errstring, "WSATYPE_NOT_FOUND  ");
		  break;
	  case WSASERVICE_NOT_FOUND:
		  sprintf (errstring, "WSASERVICE_NOT_FOUND  ");
		  break;
	  case WSASYSCALLFAILURE:
		  sprintf (errstring, "WSASYSCALLFAILURE  ");
		  break;
	  case WSAEPROVIDERFAILEDINIT:
		  sprintf (errstring, "WSAEPROVIDERFAILEDINIT  ");
		  break;
	  case WSAEINVALIDPROVIDER:
		  sprintf (errstring, "WSAEINVALIDPROVIDER  ");
		  break;
	  case WSAEINVALIDPROCTABLE:
		  sprintf (errstring, "WSAEINVALIDPROCTABLE  ");
		  break;
	  case WSAECANCELLED:
		  sprintf (errstring, "WSAECANCELLED  ");
		  break;
	  case WSAENOMORE:
		  sprintf (errstring, "WSAENOMORE  ");
		  break;



	  case 0:
		  sprintf (errstring, "No error");
		  break;
	  case 2:
		  sprintf (errstring, "No error");
		  break;

	  case WSAEDISCON:
		  sprintf (errstring, "Disconnect  ");
		  break;
	  case WSAEACCES:
		  sprintf (errstring, "Permission denied  ");
		  break;
	  case WSAEINTR:
		  sprintf (errstring, "Interrupted  ");
		  break;
	  case WSAEBADF:
		  sprintf (errstring, "Bad file number  ");
		  break;
	  case WSAEFAULT:
		  sprintf (errstring, "Bad address  ");
		  break;
	  case WSAEINVAL:
		  sprintf (errstring, "Invalid argument  ");
		  break;
	  case WSAEMFILE:
		  sprintf (errstring, "Too many open files  ");
		  break;
	  case WSAEWOULDBLOCK:
		  sprintf (errstring, "Operation would block  ");
		  break;
	  case WSAEINPROGRESS:
		  sprintf (errstring, "Blocking call in progress  ");
		  break;
	  case WSAEALREADY:
		  sprintf (errstring, "Operation already in progress  ");
		  break;
	  case WSAENOTSOCK:
		  sprintf (errstring, "Descriptor is not a socket  ");
		  break;
	  case WSAEDESTADDRREQ:
		  sprintf (errstring, "Destination address required  ");
		  break;
	  case WSAEMSGSIZE:
		  sprintf (errstring, "Data size too large  ");
		  break;
	  case WSAEPROTOTYPE:
		  sprintf (errstring,
			   "Protocol is of wrong type for this socket  ");
		  break;
	  case WSAENOPROTOOPT:
		  sprintf (errstring,
			   "Protocol option not supported for this socket type  ");
		  break;
	  case WSAEPROTONOSUPPORT:
		  sprintf (errstring, "Protocol is not supported  ");
		  break;
	  case WSAESOCKTNOSUPPORT:
		  sprintf (errstring,
			   "Socket type not supported by this address family  ");
		  break;
	  case WSAEOPNOTSUPP:
		  sprintf (errstring, "Option not supported  ");
		  break;
	  case WSAEPFNOSUPPORT:
		  sprintf (errstring, "Protocol family not supported  ");
		  break;
	  case WSAEAFNOSUPPORT:
		  sprintf (errstring,
			   "Address family not supported by this protocol  ");
		  break;
	  case WSAEADDRINUSE:
		  sprintf (errstring, "Address is in use  ");
		  break;
	  case WSAEADDRNOTAVAIL:
		  sprintf (errstring,
			   "Address not available from local machine  ");
		  break;
	  case WSAENETDOWN:
		  sprintf (errstring, "Network subsystem is down  ");
		  break;
	  case WSAENETUNREACH:
		  sprintf (errstring, "Network cannot be reached  ");
		  break;
	  case WSAENETRESET:
		  sprintf (errstring, "Connection has been dropped  ");
		  break;
	  case WSAECONNABORTED:
		  sprintf (errstring,
			   "The virtual circuit was terminated due to a time-out or other failure  ");
		  break;
	  case WSAECONNRESET:
		  sprintf (errstring,
			   "The virtual circuit was reset by the remote side  ");
		  break;
	  case WSAENOBUFS:
		  sprintf (errstring, "No buffer space available  ");
		  break;
	  case WSAEISCONN:
		  sprintf (errstring, "Socket is already connected  ");
		  break;
	  case WSAENOTCONN:
		  sprintf (errstring, "Socket is not connected  ");
		  break;
	  case WSAESHUTDOWN:
		  sprintf (errstring, "Socket has been shut down  ");
		  break;
	  case WSAETOOMANYREFS:
		  sprintf (errstring, "Too many references: cannot splice  ");
		  break;
	  case WSAETIMEDOUT:
		  sprintf (errstring, "Command timed out  ");
		  break;
	  case WSAECONNREFUSED:
		  sprintf (errstring, "Connection refused  ");
		  break;
	  case WSAELOOP:
		  sprintf (errstring, "Too many levels of symbolic links  ");
		  break;
	  case WSAENAMETOOLONG:
		  sprintf (errstring, "File name too long  ");
		  break;
	  case WSAEHOSTDOWN:
		  sprintf (errstring, "Host is down  ");
		  break;
	  case WSAEHOSTUNREACH:
		  sprintf (errstring, "No route to host  ");
		  break;
	  case WSAENOTEMPTY:
		  sprintf (errstring, "WSAENOTEMPTY  ");
		  break;
	  case WSAEPROCLIM:
		  sprintf (errstring, "Too many processes  ");
		  break;
	  case WSAEUSERS:
		  sprintf (errstring, "WSAEUSERS  ");
		  break;
	  case WSAEDQUOT:
		  sprintf (errstring, "WSAEDQUOT  ");
		  break;
	  case WSAESTALE:
		  sprintf (errstring, "WSAESTALE  ");
		  break;
	  case WSAEREMOTE:
		  sprintf (errstring, "WSAEREMOTE  ");
		  break;
	  case WSASYSNOTREADY:
		  sprintf (errstring, "Network subsystem not ready  ");
		  break;
	  case WSAVERNOTSUPPORTED:
		  sprintf (errstring, "Version not supported  ");
		  break;
	  case WSANOTINITIALISED:
		  sprintf (errstring,
			   "WSAStartup() has not been successfully called  ");
		  break;
	  case WSAHOST_NOT_FOUND:
		  sprintf (errstring, "Host not found  ");
		  break;
	  case WSATRY_AGAIN:
		  sprintf (errstring, "Host not found or SERVERFAIL  ");
		  break;
	  case WSANO_RECOVERY:
		  sprintf (errstring, "Non-recoverable error  ");
		  break;
	  case WSANO_DATA:
		  sprintf (errstring, "Host not found  ");
		  break;
	  default:
		  sprintf (errstring, "Winsock error not listed ! %d ",
			   errorcode);
		  break;
	  }

	strcpy (int_err_str, errstring);
	return;

}


////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

int
debug_rede (char *url)
{
	int ret;

/*flag de verificacao de already running*/

	if (already_running)
	  {

		  setmessage (501, "Already running");
		  rspsendmessage ();
		  return 1;

	  }

	already_running = 1;


// vai dentro da thread e nao aqui fora already_running=1;
// so importa se a thread ja estiver sendo executada
// certo ?

// vamos em frente
// que atras vem gente
// deve dar certo
// com certeza



	//  setmessage (0, "Initializing Winsock");
	//  rspsendmessage ();

	ret = initwinsock (0);
	if (!ret)
	  {

		  already_running = 0;

		  rspsendmessage ();
		  return 1;	// Unable to initialize winsock

	  }

	//  setmessage (0, "Winsock initialized");
	// rspsendmessage ();

	// setmessage (0, "Deinitializing Winsock");
	// rspsendmessage ();




// aqui vai o debug

// so vai chegar aqui se nao estiver executnado
// se estiver nem entra aqui
// entao agora o parseurl pode efetuar o servico

//dprintf("%d %d  \n", WSAECONNABORTED, WSA_OPERATION_ABORTED);

	return 0;

	if (parseurl (url))
	  {
/*nao pode parsear a url*/

// quem informa o erro  e funcao e nao aqui

		  already_running = 0;

		  return 1;

	  }

// se chegar aqui entao esta prnto para iniciar a thread e
//efetuar oque for preciso
// senao sai fora e aguarda as modificacoes

// na thread limpa o alreadyrunning na finalizacao
// o trabalho duro esta todo no thread running e em nenhum outro ponto
//certo
// vamos em frente
// entering
// faa a alocacao do buffer do tamanho
// depois voce analiza isto
// por enquanto voce nao precisa se preocupar com isto

// somente precisa fazer o codigo funcionar
// pode efetuar o download total na memoria para
// definir se vai salvar os arquivos ou nao no local
// se for fazer o download
// downloaded files not found , set thedestination folder to the mp3 files
// it wil download , play and save the media file in the local machine

	already_running = 0;


	return 0;

}

////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////


static int
setmessage (int val, char *text)
{


	strcpy (int_err_str, text);

	net_error = val;

	return 0;


}

////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

static int
rspsendmessage ()
{


	/*

	   retorna 0 se der certo
	   retorna 1 se der errado

	 */


	int ret;


	int position = (1 << 16) | 1;
/*simplesmente emite a mensagem e fim de papo*/

	//dprintf ("Posicao %x \n", position);

//dprintf("Antes de send message \n");

	//  ret = SendMessage ((HWND) messagewindow, 0x206, MK_CONTROL, position);

	if (isalive ())
	  {

		  ret = SendMessage ((HWND) messagewindow, 0x206, MK_CONTROL,
				     position);
		  ret = 0;

	  }
	else
	  {
		  ret = 1;
	  }

//dprintf("Depois de send message \n");

	return ret;

}

////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

int
set_sendmessage_nwnd (int value)
{

	messagewindow = value;

	dprintf ("setando messagewindow para %d \n", value);

	return 0;

}

////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

char *
getnetstatus (int *value)
{

	*value = net_error;

	return int_err_str;

}


////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////


static int
isalive ()
{

/*retorno 1 se estiver valido o hwnd
  retorna 0 se estiver deascarregado
*/
	int ret;

	ret = IsWindow ((HWND) messagewindow);

	if (0 == ret)
	  {

		  mprintf ("HWD Window invalid \n");

		  return 0;
	  }



	return 1;
}

////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

int
isurl (char *url)
{

	int ret;
	char *temp;
	int sizeis = 0;
	char header[255];

	ret = strlen (url);

	if (!ret)
	  {

		  return 0;

	  }

	temp = malloc (ret + 255);

	memset (temp, 0, 255);

	strcpy (temp, url);

	dprintf ("String a ser testada antes .%s. \n", temp);

	strtolower (temp);

	removedordeespaconoinicio (temp);
	removedordeespaconofinal (temp);

	dprintf ("String a ser testada .%s. \n", temp);


	if (!memcmp (temp, "http://", 7))
	  {

		  sizeis = 7;
		  dprintf ("is http \n");

	  }
	else if (!memcmp (temp, "ftp://", 6))
	  {
		  sizeis = 6;
		  dprintf ("is ftp \n");

	  }
	else
	  {
		  dprintf ("no protocol \n");
		  sizeis = 0;
	  }

	free (temp);

	dprintf ("isulr == %d \n", sizeis);

	return sizeis;

}


static int
ishttp (char *url)
{

	int ret;
	char *temp;
	int sizeis = 0;
	char header[255];

	ret = strlen (url);

	if (!ret)
	  {

		  return 0;

	  }

	temp = malloc (ret + 255);

	memset (temp, 0, 255);

	strcpy (temp, url);

	//  dprintf ("String a ser testada antes .%s. \n", temp);

	strtolower (temp);

	removedordeespaconoinicio (temp);
	removedordeespaconofinal (temp);

	//  dprintf ("String a ser testada .%s. \n", temp);


	if (!memcmp (temp, "http://", 7))
	  {

		  sizeis = 1;
		  //dprintf ("is http \n");

	  }
	else if (!memcmp (temp, "ftp://", 6))
	  {
		  sizeis = 0;
		  //dprintf ("is ftp \n");

	  }
	else
	  {
		  //dprintf ("no protocol \n");
		  sizeis = 0;
	  }

	free (temp);

	//dprintf ("isulr == %d \n", sizeis);

	return sizeis;

}

////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

static void
url_encode (char **url)
{
/*

aprenmdi mais uma

tem que coocar sempre uma definicao de acordo comaquela
que esta vindo do systema

*/

	int tamanho;


	int ret;

	unsigned char *temp = NULL;

	unsigned char *here = *url;

	if ((here == NULL))
	  {
		  dprintf ("String invalida url_encode \n");
		  return;

	  }

	if (!strlen (here))
	  {
		  dprintf ("url_encode Invalido tamanho \n");
		  return;
	  }

//dprintf("sizeof(**url) %d \n", sizeof(**url));
//dprintf("sizeof(*url) %d \n", sizeof(*url));
//dprintf("sizeof(url) %d \n", sizeof(url));

	dprintf ("Endereo dentro %d \n", here);

	dprintf ("String para url_encode .%s.\n", here);

	ret = pegaposicaoinsensitive (here, "#");

	if (ret)
	  {

		  here[ret - 1] = 0;
	  }

	tamanho = strlen (here) * 4;

	temp = malloc (strlen (here) * 4);

	memset (temp, 0, (strlen (here) * 4));


	dprintf ("Tamanho alocado %d\n", strlen (here) * 4);

	{
		int i;

		char copia[5];

		memset (copia, 0, 5);

/*aqui efetua a modificacao*/

		dprintf ("String %s \n", here);

		for (i = 0; i < strlen (here); i++)
		  {
			  char hexa[20];
			  int fixo;



			  if (here[i] >= 0x80)
			    {
				    /*encode */
				    fixo = here[i];

				    sprintf (hexa, "%%%02x", fixo);
				    strcat (temp, hexa);
				    continue;
			    }

			  if (here[i] == ' ')
			    {
				    /*encode */
				    fixo = here[i];

				    sprintf (hexa, "%%%02x", fixo);
				    strcat (temp, hexa);
				    continue;
			    }

			  if (here[i] == 0x7f)
			    {
				    /*encode */
				    fixo = here[i];

				    sprintf (hexa, "%%%02x", fixo);
				    strcat (temp, hexa);
				    continue;
			    }

			  if (here[i] <= 0x1f)
			    {
				    /*encode */
				    fixo = here[i];

				    sprintf (hexa, "%%%02x", fixo);
				    strcat (temp, hexa);
				    continue;
			    }

			  if (here[i] == '<')
			    {
				    /*encode */
				    fixo = here[i];

				    sprintf (hexa, "%%%02x", fixo);
				    strcat (temp, hexa);
				    continue;
			    }

			  if (here[i] == '>')
			    {
				    /*encode */
				    fixo = here[i];

				    sprintf (hexa, "%%%02x", fixo);
				    strcat (temp, hexa);
				    continue;
			    }

			  if (here[i] == '\"')
			    {
				    /*encode */
				    fixo = here[i];

				    sprintf (hexa, "%%%02x", fixo);
				    strcat (temp, hexa);
				    continue;
			    }
			  if (here[i] == '`')
			    {
				    /*encode */
				    fixo = here[i];

				    sprintf (hexa, "%%%02x", fixo);
				    strcat (temp, hexa);
				    continue;
			    }




/*URLs are written only with the graphic printable
characters of the

   US-ASCII coded character set.

   The octets 80-FF hexadecimal are not
   used in US-ASCII, and the octets 00-1F
   and 7F hexadecimal represent
   control characters; these must
   be encoded.*/


			  copia[0] = here[i];
			  strcat (temp, copia);


		  }

	}

	dprintf ("Depois de modifixcado .%s. \n", temp);

	dprintf ("Endereco sendo liberado %d \n", here);
	free (here);

	dprintf ("Tamanho de tamanho %d\n", tamanho);

	here = malloc (tamanho);


	strcpy (here, temp);


	*url = here;

	free (temp);

	return;

}


////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

/*se voce manda o arquivo entao  URL nao  mesmo ?*/

static int
parseurl (char *url)
{

/*

   retorna 0 se der certo ,
   retorna 1 se der errado

   Se der 0 entao esta pronto para inciar o download


   */
/*

se aqui vai alrear as variaveis globais , entao aqui tem que testas se ja esta redando ou nao
e nao la fora

*/

	int ret;

	int getuser = 0;


	ret = strlen (url);

	if (!ret)
	  {

		  setmessage (502, "Invalid URL");
		  rspsendmessage ();

		  return 1;

	  }

	ret = isurl (url);

	if (!ret)
	  {

		  setmessage (502, "Invalid URL");
		  rspsendmessage ();

		  return 1;

	  }


// aqui efetua oque falta
// se retorna 0 entao ja esta tudo pronto
// calma voce nao ta la dentro ainda
// tenha calma , tem que chegarla primeiro
// nao chegou ainda
// somente precisa tirar as informacoes necessarias
// e ir utilizando os outros itens dentro
// vai dividindo de pouco em pouco ate o final dos itens
// certo
// vamos em frente que atras vem gente
// ants de criar o codigo precisa saber como converter
// entao vamos la
	{
		int ret;

		static char *turl = NULL;

		if (turl != NULL)
		  {
			  free (turl);
			  turl = NULL;
		  }

		turl = malloc (strlen (url) + 2);

		strcpy (turl, url);

		removedordeespaconoinicio (turl);

		trocadordebackslashfrente (turl);

		is_http = ishttp (turl);


		// vai estudar ou vai queree desenvolver sem saber ?
		// faa a coisa certa
		// primeiro pega a primeira parte
		/*

		   static char *intproto = NULL;
		   static char *inturl = NULL;
		   static char *intpath = NULL;
		   static char *intfile = NULL;
		   static char *intuser = NULL;
		   static char *intpassword = NULL;

		 */


		if (NULL != intproto)
		  {
			  //  dprintf ("Finalizando Variaveis \n");

			  free (intproto);
			  intproto = NULL;
		  }

		if (NULL != inturl)
		  {
			  free (inturl);
			  inturl = NULL;
		  }

		if (NULL != intpath)
		  {
			  free (intpath);
			  intpath = NULL;
		  }

		if (NULL != intfile)
		  {
			  free (intfile);
			  intfile = NULL;
		  }

		if (NULL != intuser)
		  {
			  free (intuser);
			  intuser = NULL;
		  }

		if (NULL != intpassword)
		  {
			  free (intpassword);
			  intpassword = NULL;
		  }

		if (NULL != intport)
		  {
			  free (intport);
			  intport = NULL;
		  }


// podemos agira aqui
		//   dprintf ("Inicializando Variaveis %d\n", strlen (url) + 2);

		intproto = malloc (strlen (url) + 2);
		inturl = malloc (strlen (url) + 2);
		intpath = malloc (strlen (url) + 2);
		intfile = malloc (strlen (url) + 2);
		intuser = malloc (strlen (url) + 2);
		intpassword = malloc (strlen (url) + 2);
		intport = malloc (strlen (url) + 2);


// podemos agir que ja ha espaco o suficiente


// primeiro pega ao protocolo

		ret = pegaposicaoinsensitive (turl, "://");

		strcpy (intproto, turl);
		intproto[ret + 2] = 0;

		memset (inturl, 0, strlen (turl));
		memset (intpath, 0, strlen (turl));
		memset (intfile, 0, strlen (turl));
		memset (intuser, 0, strlen (turl));
		memset (intpassword, 0, strlen (turl));
		memset (intport, 0, strlen (turl));

		strcpy (inturl, &turl[ret + 2]);


/*
		if(inturl[strlen(inturl)-1] = '/')
{
	dprintf("Fixando URL \n");
		inturl[strlen(inturl)-1] = 0;
}
*/

//dprintf("Protocolo pego .%s. \n",intproto );

//dprintf("inturl pego .%s. \n",inturl );

		ret = pegaposicaoinsensitive (inturl, "/");

		if (ret)
		  {

			  strcpy (intpath, &inturl[ret - 1]);

		  }
		else
		  {
			  intpath[0] = '/';
			  intpath[1] = 0;
		  }


// aqui ja pode consertar o inturl

		ret = pegaposicaoinsensitive (inturl, "/");

		if (ret)
		  {

			  inturl[ret - 1] = 0;

		  }

//dprintf("inturl fixado pego .%s. \n",inturl );


//dprintf("intpath pego .%s. \n",intpath );

		ret = pegaposicaoinsensitivefinal (intpath, "/");

		if (ret)
		  {

			  strcpy (intfile, &intpath[ret]);

			  intpath[ret] = 0;
		  }

		if (0 == strlen (inturl))
		  {


			  setmessage (502, "Invalid URL");
			  rspsendmessage ();

			  return 1;
		  }




// ok , agora vamos ver em que categoria se expressa aquilo la
// se no meio no comeco ou nao final

		ret = contastringsensitive (inturl, ":");

		if (ret == 2)
		  {

			  int a;
			  int b;
			  int c;


			  ret = contastringsensitive (inturl, "@");
			  if (0 == ret)
			    {


				  errorurl:

				    setmessage (502, "Invalid URL");
				    rspsendmessage ();

				    return 1;


			    }

			  a = pegaposicaoinsensitive (inturl, ":");

			  b = pegaposicaoinsensitive (inturl, "@");

			  c = pegaposicaoinsensitivefinal (inturl, ":");


			  if (a > b)
			    {
				    goto errorurl;
			    }

			  if (b > c)
			    {
				    goto errorurl;
			    }

		  }














		ret = contastringsensitive (inturl, ":");

		if ((ret != 0) && (ret != 1) && (ret != 2))
		  {

			  setmessage (502, "Invalid URL");
			  rspsendmessage ();

			  return 1;

		  }

		ret = contastringsensitive (inturl, "@");

		if ((ret > 1))
		  {

			  setmessage (502, "Invalid URL");
			  rspsendmessage ();

			  return 1;

		  }

/*agora precisamos saber como dividir as coisas*/

// primeiro remova o protocolo que  mais facil
// di fica mais simples de fazer o resto funcionar
		ret = pegaposicaoinsensitivefinal (inturl, ":");

		strcpy (intuser, inturl);
// fazendo so user para depois

		if (ret)
		  {


			  /*quer dizer que tem : se  porta ou nao nao se sabe */


			  int ret3;

			  ret3 = pegaposicaoinsensitive (inturl, ":");

/*aqui vamos ver se tem mais de um :*/

			  if (ret == ret3)	// quer dizer que so tem um pose ser porta ou password
			    {
				    int ret4;


				    ret4 = pegaposicaoinsensitive (inturl,
								   "@");


				    if (ret4)
				      {

/*pode ser um user e pass ou user e porta como detectar isto */

					      if (ret4 > ret)
						{
							/*quer dizer que nao  porta */

							getuser = 1;
							goto tira;

						}

				      }
				    //tudo bem  porta

				    // nao  porta , entao oque fazer ?//
				    // somente tem um item , entao vamos agor desta forma


				    //e dai jumpear depois

				    strcpy (intport, &inturl[ret]);
				    inturl[ret - 1] = 0;



				    goto saida;




			    }


			contok:

			  getuser = 1;

			  strcpy (intport, &inturl[ret]);
			  inturl[ret - 1] = 0;

			tira:

			  ret = pegaposicaoinsensitive (inturl, ":");



			  if (ret)
			    {
				    int ret2;

				    ret2 = strlen (&inturl[ret]);

				    memmove (inturl, &inturl[ret], ret2);

				    inturl[ret2] = 0;

			    }


			  ret = pegaposicaoinsensitive (inturl, "@");

			  if (ret)
			    {


				    int ret2;

				    ret2 = strlen (&inturl[ret]);



				    memmove (inturl, &inturl[ret], ret2);

				    inturl[ret2] = 0;

			    }

		  }


	      saida:


		//     dprintf ("porta pega .%s. \n", intport);




		if (getuser)
		  {

			  // dprintf ("Get user sim \n");

			  ret = pegaposicaoinsensitive (intuser, "@");

			  if (ret)
			    {
				    int ret2;

/*Aqui considera que tem o divisor , entao fica mais facil*/

				    //strcpy(intuser,inturl);
				    intuser[ret - 1] = 0;

				    //      dprintf ("User dentro %s \n", intuser);

				    ret2 = pegaposicaoinsensitive (intuser,
								   ":");

				    if (ret2)	//tem password entao tire
				      {

					      strcpy (intpassword,
						      &intuser[ret2]);

					      intuser[ret2 - 1] = 0;

				      }


			    }
		  }
		else
		  {

			  int hasuser = 0;

			  char *temp = NULL;

			  temp = malloc (strlen (inturl) + 2);




/*se estamos aqui , entao nao tem password*/
			  // intuser[0] = 0;

			  //  dprintf ("Get user nao \n");

			  intpassword[0] = 0;



			  ret = pegaposicaoinsensitive (inturl, "@");

			  if (ret)
			    {
//ta aqui o finalizador
				    //dprintf ("passando por @ \n");


				    hasuser = 1;

				    strcpy (intuser, inturl);


				    strcpy (inturl, &intuser[ret]);

				    intuser[ret - 1] = 0;

				    strcpy (temp, intuser);



			    }



			  ret = pegaposicaoinsensitive (inturl, ":");

			  if (ret)
			    {
//ta aqui o finalizador

				    //dprintf ("passando por : \n");



				    strcpy (intuser, inturl);


				    strcpy (inturl, &intuser[ret]);
				    //dprintf ("Intuser antes %s \n", intuser);
				    //intuser[0] = 0;
				    //dprintf ("Intuser depois %s \n", intuser);

			    }

//intuser[0]=0;


			  if (hasuser)
			    {

				    strcpy (intuser, temp);


			    }
			  else
			    {

				    intuser[0] = 0;

			    }

			  if (temp)
			    {
				    free (temp);

			    }

		  }

		if (isalpha (inturl[0]))
		  {

			  //dprintf ("  alpha \n");

		  }
		else
		  {

			  //dprintf ("nao   alpha \n");
			  setmessage (502, "Invalid URL");
			  rspsendmessage ();

			  return 1;
		  }



		dprintf (" \n\n\n\n\n");
		dprintf ("Protocolo  .%s. \n", intproto);
		dprintf ("user pego .%s. \n", intuser);

		dprintf ("pass pego .%s. \n", intpassword);

		dprintf ("url  .%s. \n", inturl);

		dprintf ("porta pega .%s. \n", intport);


		dprintf ("arquivo .%s. \n", intfile);

		dprintf ("path  .%s. \n", intpath);

		dprintf ("Is http ? %d \n", is_http);
		dprintf ("\n");


		/*

		   e agora efetuar a modificacao dos itens de acordo
		   com a informacao proposta os itens passados

		   faz isto no path , no arquivo e no host

		 */
		/*somente o path e o arquivo precisam disto */

		dprintf ("String antes .%s. \n", intpath);

		dprintf ("Endereo passnado %d \n", intpath);

		//intpath[1]= 0x1;

		//intpath[2]= 0;
		url_encode (&intpath);

		dprintf ("Endereco depois %d \n", intpath);

		dprintf ("String depois .%s. \n", intpath);

	}

	setmessage (0, "Meu status");
	rspsendmessage ();


	return 0;

}

////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////


/*

esta quase pronto basta adicionar o codigo que acessa a internet

e o carregador do wininet tambem

LoadLibrary no winint se nao estiver na memoria ainda

E depois segue em frente direto

Ok

NetWork Error

***********************

Deve funcionar de acordo pode crer

Deve dar certo

Veremos se isto se aplica ou nao

Concorda ?

Veremos se da certo
Se der , entao tudo bem mesmo

Vamos em frente que atras vem gente

Vamos fazer funcionar esta bosta


*/
