/*

Mon Apr 25 GMT 17:44:37 2011 , by arab

*/
/*

RSPsoftware

If you have any doubts take a look in the MP3 OCX , since it has a fully functional sample and the name 
and utilization of the functions are almost the same

Link for the ocx: http://rspsoftware.com.br/my_dad_special_release.htm
Alternate       : http://maquisistem.tripod.com/~Maquisistem/rspmp3play.htm

This sample will be finished as soon I got time....

If you have time and want to contribute , just finish the documentation of:
mp3class.cs

The DLL is fully functional and can be used in shareware or comercial
software without modifications , since now the method of registration
is by user name and unlock code (function Enter_License)

As usual , free upgrades to two years (and can be extended by request)

We will always deliver new releases for any user that have 
purchased this control/OCX/dll since 1996 , just ask....

*/


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Diagnostics;

///great name, developed by me, Alladin
namespace mp3dll
{


    /// <summary>
    /// The MP3 class is the class to play or decode with full multiplayer support MP3 or other formats
    /// </summary>
    /// <remarks>
    /// remarks section
    /// </remarks>
    public class MP3
    {

        /// <summary>
        /// It will send debug information to the installed debugger
        /// Debugview by sysinternals in our case
        /// http://technet.microsoft.com/en-us/sysinternals/bb896647.aspx
        /// 
        /// 
        /// void WINAPI OutputDebugString(
        ///__in_opt  LPCTSTR lpOutputString
        ///);
        ///
        /// </summary>
        /// <param name="lpOutputString"></param>
        [DllImport("kernel32.dll")]
        static extern void OutputDebugString(string lpOutputString);

        /// <summary>
        /// Our internal debug function (arabcoder)
        /// </summary>
        /// <param name="data">the data to send</param>
        public static void dprintf(string data)
        {
            data = data + " _debug_";

            OutputDebugString(data);
        }
        /// <summary>
        /// This is the function to play the media file<br></br><br></br>
        ///
        /// For the moment it supports the following media files:<br></br>
        /// mpg mp1 mp2 mp3 wav in pcm format<br></br>
        /// But a future version using ffmpeg will be able to decode and play all the known media formats<br></br>
        ///
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// filename - The media file to play<br></br>
        /// loop - Whether the playback will loop , if 1 it will loop for ever<br></br>
        ///  <br></br><br></br>
        ///  The playback will initialize as soon the function is called , and the function returns immediatelly also
        /// </summary>
        /// <remarks>
        ///
        /// </remarks>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        PlayMp3(int number, string filename, int loop);

        /// <summary>
        /// This is the function to play the media file<br></br><br></br>
        ///
        /// For the moment it supports the following media files:<br></br>
        /// mpg mp1 mp2 mp3 wav in pcm format<br></br>
        /// But a future version using ffmpeg will be able to decode and play all the known media formats<br></br>
        ///
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// filename - The media file to play<br></br>
        /// loop - Whether the playback will loop , if 1 it will loop for ever<br></br>
        ///  <br></br><br></br>
        ///  The media file will be loaded and wait until PlaybackResume is called , and the function returns immediatelly also
        /// </summary>
        /// <remarks>
        ///
        /// </remarks>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        OpenMp3(int number, string filename, int loop);


        /// <summary>
        /// This function will return the status of the playback , if > 999 then it is playing<br></br>
        /// It is required to control the playback
        /// <br></br><br></br>
        ///Since this is the most important function to control the end of the playback you need to understand how it work correctly
        ///<br></br><br></br>The return value can be passed to GetErrorString to retrieve a string with the result of the playback
        ///<br></br>Values:
        ///<br></br>0-"No error"
        ///<br></br>2-"Error opening waveout"
        ///<br></br>3-"Input does not appear to be a wav file"
        ///<br></br>4-"Error reading first page of Ogg bitstream data"
        ///<br></br>5-"Error reading initial header packet"
        ///<br></br>6-"This Ogg bitstream does not contain Vorbis"
        ///<br></br>7-"Corrupt secondary header"
        ///<br></br>8-"End of file before finding all Vorbis headers!"
        ///<br></br>9-"No valid devices in the system"
        ///<br></br>10-"Cannot open media file"
        ///<br></br>20-"Input does not appear to be a wav file"
        ///<br></br>21-"Only PCM wav files can play"
        ///<br></br>22-"Invalid number of bits per sample"
        ///<br></br>24-"Invalid MPEG file"
        ///<br></br>25-"Invalid number of channels"
        ///<br></br>26-"Invalid sample rate"
        ///<br></br>300-"Tampering detected , please reinstall the component"
        ///<br></br>1000-"Playing..."
        ///<br></br>1001-"Playback paused"<br></br>
        ///<br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        IntReturn(int number);


        /// <summary>
        ///It is used to pause the playback
        /// <br></br><br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        PlaybackPause(int number);


        /// <summary>
        ///It is used to resume the playback or initiate the playback if the function OpenMp3 was used
        /// <br></br><br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        PlaybackResume(int number);




        /// <summary>
        ///It is used to cancel the playback
        /// <br></br><br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        PlaybackCancel(int number);



        /// <summary>
        ///It is used to retrieve the samplerate of the media file
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        SampleRate(int number);


        /// <summary>
        ///It will retrieve the number of channels of the media file
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        Channels(int number);



        /// <summary>
        ///To retrieve the playback position in milliseconds
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GetTimeMilliseconds(int number);

        /// <summary>
        ///To retrieve the playback time in seconds
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        GetTime(int number);

        /// <summary>
        ///It will retrieve the playback time in a formatted string
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        GetTimeString(int number, StringBuilder time);


        /// <summary>
        ///It will retrieve the length of the media file as a formatted string
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        GetLengthString(int number, StringBuilder time);


        /// <summary>
        ///It will retrieve the length of the media file as milliseconds
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        GetLengthMilliseconds(int number);



        /// <summary>
        ///It will retrieve the length of the media file as seconds
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        GetLength(int number);

        /// <summary>
        ///It will finish the playback and close the player
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        ClosePlayer(int number);


        /// <summary>
        ///It will seek on the media playback<br></br><br></br>
        ///seek - The value to seek in percentage (0 to 100)<br></br>
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        SeekTo(int number, double seek);
        /// <summary>
        ///It will get the progress position as percentage (0 to 100)<br></br>
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>

        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        PlayBackPosition(int number);


        /// <summary>
        ///It will set the priority of the playback<br></br>
        ///0 - Idle processor time<br></br>
        ///1 - Normal processor time<br></br>
        ///2 - High processor time<br></br>
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        SetPriority(int number, int priority);


        /// <summary>
        ///<br></br>This function will change the volume of the playback<br></br>
        ///<br></br>In the version 2.5.0 this function was modified , now it range from 0 to 100 and not from 0 to 10 anymore<br></br>
        ///<br></br>Notice that this function access the system mixer , then it affect the volume of any file playing , if you want to change only the playback of the file playing in the control , then use the InternalVolume function , now the InternalVolume function is the preferred way to change volume playback<br></br>
        ///<br></br>A value of 0 will mute the playback , a value of 100 to maximum volume<br></br>
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        SetVolumeGain(int number, int value);



        /// <summary>
        ///It will define the wave out device that will play the media file , it range from 0 to the number of wave out devices less 1 , use GetNumberofWaveOutDevices to retrieve the number of wave out devices
        ///
        /// <br></br><br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        SetWaveOutDevice(int number, int device);


        /// <summary>
        ///It will return the name of the selected wave out device in the data variable
        /// <br></br><br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        GetWaveOutDevicesName(int number, int device, StringBuilder data);

        /// <summary>
        ///It will return whether the media file is VBR (variable bit rate)
        /// <br></br><br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        GetVBR(int number);


        /// <summary>
        ///It will retrieve the bitrate of the media file (if applicable)
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        GetBitrate(int number);


        /// <summary>
        ///
        /// <br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        GetMpegVersion(int number, StringBuilder version);



        /// <summary>
        ///It will retrieve the layer of the mpeg file
        /// <br></br><br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GetMpegLayer(int number, StringBuilder layer);


        /// <summary>
        ///It will retrieve the stereo mode
        /// <br></br>
        /// 
        ///  It can be:<br></br>
        /// "Stereo", "Joint-Stereo", "Dual-Channel" or "Single-Channel"<br></br><br></br>
        ///
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GetMpegMode(int number, StringBuilder mode);



        /// <summary>
        ///It will convert mp3 files to wav pcm files
        /// <br></br><br></br>
        ///input - the input mp3 file<br></br>
        ///output - the output wav file<br></br>
        ///Notice that the function will only return after the end of the conversion<br></br>
        ///<br></br>
        ///Return values<br></br>
        ///	               
        ///05 - Invalid input file<br></br>
        ///06 - Invalid output<br></br>
        ///49 - Invalid input file<br></br>
        /// <br></br><br></br>
        /// number - The player selector , for each different player a different number need to be used<br></br>
        /// but for a single player mode just always pass 1<br></br>
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int

        ConvertMP3ToWav(int number, string input, string output);

        /**<summary>

        <br></br>This function will enable or disable the equalizer<br></br>
        <br></br> When enabled , it will use the values passed to the function EqualizerSettings<br></br>
        <br></br>If the call to the function EqualizerSettings was not done yet , then it will define the values as the initial position of the equalizer , it will be 50 for each argument to the EqualizerSettings function <br></br>
        <br></br>The equalizer provide +-12 db of gain , ranging from value 0 to 100 , 50 is the middle or no gain , when the DoubleBuffer is enabled the gain is enhanced a little more , but it can introduce a little noise or distortion<br></br>
        <br></br><br></br>
        number - The player selector , for each different player a different number need to be used<br></br>
        but for a single player mode just always pass 1<br></br>
        </summary>
        */
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableEqualizer(int number, int enable);



        /**<summary>
         
        <br></br>This function will change the settings of the equalizer<br></br>
        <br></br>The value to be passed to each argument range from 0 to 100 , 50 is the middle or no gain in equalization
        <br></br>Band60 = 60 hertz
        <br></br>Band170 = 170 hertz
        <br></br>Band310 = 310 hertz
        <br></br>Band600 = 600 hertz
        <br></br>Band1000 = 1 kilohertz
        <br></br>Band3000 = 3 kilohertz
        <br></br>Band6000 = 6 kilohertz
        <br></br>Band12000 = 12 kilohertz
        <br></br>Band14000 = 14 kilohertz
        <br></br>Band16000 = 16 kilohertz
        <br></br>
 <br></br>
        number - The player selector , for each different player a different number need to be used<br></br>
        but for a single player mode just always pass 1<br></br>
        </summary>
        */
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EqualizerSettings(int number, int Band60, int Band170, int
        Band310, int Band600, int Band1000, int
        Band3000, int Band6000, int Band12000, int
        Band14000, int Band16000);

        /**<summary>
        <br></br>This function will enable or disable the preamplifier, 
        to control the preamplifier call the function PreamplifierValue<br></br>
        <br></br>
        number - The player selector , for each different player a different number need to be used<br></br>
        but for a single player mode just always pass 1<br></br>
         * </summary>
        */
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnablePreamplifier(int number, int enable);

        /**<summary>
<br></br>This function will set the preamplifier value to be used , a value of 50 means no preamplifier gain , a value of 0 means no sound , a value of 100 means the double of the value of each sample playing , then if the value of the sample is 5000 and this function receive a value 100 the sample will be modified to 10000 , it can be used to increase the volume of mp3 files generated with very low volume<br></br>
        <br></br>
        number - The player selector , for each different player a different number need to be used<br></br>
        but for a single player mode just always pass 1<br></br>
          </summary>
*/
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        PreamplifierValue(int number, int value);

/**<summary>
<br></br>This function will change the internal volume of the file playing, it work in a similar mode as the SetVolumeGain function but it don't affect the other files playing, since it is internal to each control , then this is the preferred mode to change the volume of the playback now, it was introduced in the version 2.5.0 of the mp3 control, the SetVolumeGain function only need to be used when you really want to change the volume of the system mixer
notice that you can pass 200 as the volume value, it will increase the internal stream playing to 200%, it is usefull if the recorded mp3 have low playback volume level<br></br>
<br></br>
number - The player selector , for each different player a different number need to be used<br></br>
but for a single player mode just always pass 1<br></br>
</summary>
*/
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        InternalVolume(int number, int value);

        /**<summary>
         
<br></br>This function will enable or disable the on the fly volume normalization
<br></br>If Enabled = True and the file playing don't have the normalization volume tag , it will generate on the fly the value and adjust the volume level to the referred value, when the value need to be generated on the fly due to the absence of the volume tag , it will requires a few seconds depending on the speed of your processor
<br></br>If Enabled = True and the file playing has the volume normalization tag , it will read the information from the tag and adjust the volume level to the referred value , this mode is faster because it don't need to spend time on the generation of the value
<br></br>
        number - The player selector , for each different player a different number need to be used<br></br>
        but for a single player mode just always pass 1<br></br>
</summary>
*/
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableOnTheFlyVolumeNormalizationFast(int number, int enable);
        [DllImport("rspmp3ocx1.dll")]
        public static extern int


                    /**<summary>
        <br></br>This function will enable or disable the on the fly volume normalization
<br></br>If Enabled = True and the file playing don't have the normalization volume tag , it will generate on the fly the value and adjust the volume level to the referred value, when the value need to be generated on the fly due to the absence of the volume tag , it will requires a few seconds depending on the speed of your processor
<br></br>If Enabled = True and the file playing has the volume normalization tag , it will read the information from the tag and adjust the volume level to the referred value , this mode is faster because it don't need to spend time on the generation of the value
<br></br>
        number - The player selector , for each different player a different number need to be used<br></br>
        but for a single player mode just always pass 1<br></br>
        </summary>
        */
        EnableOnTheFlyVolumeNormalization(int number, int enable);


        /**<summary>
<br></br>This function will enable or disable the on the fly volume normalization and will add the volume normalization tag to the file
<br></br>If Enable = True and the file playing don't have the normalization volume tag , it will generate on the fly the value and adjust the volume level to the referred value, and also it will try to add the volume tag to the file , when the value need to be generated on the fly due to the absence of the volume tag , it will requires a few seconds depending on the speed of your processor
<br></br>If Enable = True and the file playing has the volume normalization tag , it will read the information from the tag and adjust the volume level to the referred value , this mode is faster because it don't need to spend time on the generation of the value
        <br></br>
        number - The player selector , for each different player a different number need to be used<br></br>
        but for a single player mode just always pass 1<br></br>
</summary>
*/
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableOnTheFlyVolumeNormalizationAndWriteTAGFast
        (int number, int enable);


        /**<summary>
<br></br>This function will enable or disable the on the fly volume normalization and will add the volume normalization tag to the file
<br></br>If Enable = True and the file playing don't have the normalization volume tag , it will generate on the fly the value and adjust the volume level to the referred value, and also it will try to add the volume tag to the file , when the value need to be generated on the fly due to the absence of the volume tag , it will requires a few seconds depending on the speed of your processor
<br></br>If Enable = True and the file playing has the volume normalization tag , it will read the information from the tag and adjust the volume level to the referred value , this mode is faster because it don't need to spend time on the generation of the value
        <br></br>
        number - The player selector , for each different player a different number need to be used<br></br>
        but for a single player mode just always pass 1<br></br>
</summary>
*/
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableOnTheFlyVolumeNormalizationAndWriteTAG
        (int number, int enable);




        /**<summary>
<br></br>This function will make the equalizer to provide the double of the gain
<br></br>It was added because some users have reported that the response of the equalizer was not enough
<br></br>Now it provides more gain than Winamp or Media Player equalizer , indeed , it can even introduce a little noise or distortion when the gain is set to the maximum
        <br></br>
        number - The player selector , for each different player a different number need to be used<br></br>
        but for a single player mode just always pass 1<br></br>
          </summary>
*/
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        DoubleBuffer(int number, int enable);


        /**<summary>
<br></br>It will return the paused state of the player
         <br></br>Return 1 if paused
         <br></br>
        number - The player selector , for each different player a different number need to be used<br></br>
        but for a single player mode just always pass 1<br></br>
</summary>
*/
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        PauseState(int number);

        /**<summary>
<br></br>This function will try to locate the tag on the file , if the tag exist it will return 0 , if the tag don't exist it will be generated and added to the file
<br></br>In case of errors the function will return a value different of 0
<br></br>Valid return values :
<br></br>0 - no error, tag ok
<br></br>1 - file don't exist or too small
<br></br>2 - cannot open file to read or write
<br></br>3 - file is read only
<br></br>4 - unable to generate the volume normalization value
<br></br>5 - the file isnot a valid OGG Vorbis file (only will occur in the OGG vorbis control OCX )

         <br></br>
        number - The player selector , for each different player a different number need to be used<br></br>
        but for a single player mode just always pass 1<br></br>
        </summary>
*/
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GenerateVolumeTag(int number, string filename);


        //more documentation information will be added soon, promised

        /// <summary>
        /// This function will check to see whether the file has or not the normalization volume tag
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="filename">The filename</param>
        /// <returns>0 - File have volume tag<br></br>
        /// 1 - File don't have volume tag
        /// </returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        CheckVolumeTag(int number, string filename);


        /// <summary>
        /// This function will change the playback position based on seconds , then if you pass 50.523 to this function it will seek to the second 50.523 in the playback , it can be used to control the initial playback position based on time , it is as accurated as 30 milliseconds division , this mean that you can jump to any point in the file with a maximum subdivions of 30 milliseconds , and I am sure that it is enough , notice that this is the mp3 limitation since any mp3 frame has at most 30 milliseconds of data on it
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="value">The value to pass</param>
        /// <returns>Always 0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        SeekBasedOnSeconds(int number, double value);

        /// <summary>
        /// This function will inform whether volume normalization is being used , for more information about volume normalization support in our controls check http://rspsoftware.com.br/rspnormalization.htm
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <returns>0 - if no normalization is being used
        /// <br></br>1 - if normalization is being used
        /// </returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        IsUsingNormalization(int number);


        /// <summary>
        /// This function will retrieve the normalization factor being used , 
        /// this information has no useful value other than showing the 
        /// multiplication factor in the media file , then  if it show 1.000 , 
        /// it means that each sample is 
        /// being multiplied by 1.0 and sent to the soundcard
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="value">The string with the information returns here</param>
        /// <returns>Always 0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        NormalizationFactor(int number, StringBuilder value);

        /// <summary>
        /// This function return the right channel peak level
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <returns>The peak level</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GetRightChannel(int number);

        /// <summary>
        /// This function return the left channel peak level
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <returns>The peak level</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GetLeftChannel(int number);

        /// <summary>
        /// This function will read the id3 v1/1.1 tag
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="filename">The mp3 file</param>
        /// <param name="Track">The track</param>
        /// <param name="Title">The title</param>
        /// <param name="Artist">The artist</param>
        /// <param name="Album">The album</param>
        /// <param name="Year">The year</param>
        /// <param name="Genre">The genre</param>
        /// <param name="Comment">The comment</param>
        /// <returns>0 - no error<br></br>
        /// 1 - cannot open file<br></br>
        /// 2 - id3 tag not found<br></br>
        /// 3 - invalid file<br></br>
        /// </returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        Read_ID3_v1_tag(int number, StringBuilder filename, ref int Track, StringBuilder Title, StringBuilder Artist,
        StringBuilder Album, StringBuilder Year, ref int Genre, StringBuilder Comment);
        
        /// <summary>
        /// It will return the genre names based on the number 'pos' , it range from 0 to 148
        /// The genre list is the same genre list supported by Winamp , indeed the whole ID3 tag support on this control was based exactly in the same way it is support and implemented in Winamp
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="pos">array position, from 0 to 148</param>
        /// <param name="data">Where the string returns</param>
        /// <returns>Always 0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        Generate_ID3v1Genre(int number, int pos, StringBuilder data);

        /// <summary>
        /// This fuction will write the id3 v1 tag on the file
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="filename">The MP3 file</param>
        /// <param name="Track">Track</param>
        /// <param name="Title">Title</param>
        /// <param name="Artist">Artist</param>
        /// <param name="Album">Album</param>
        /// <param name="Year">Year</param>
        /// <param name="Genre">Genre</param>
        /// <param name="Comment">Comment</param>
        /// <returns>0 - no error<br></br>
        /// 1 - cannot open mp3 file<br></br>
        /// 2 - file is too small<br></br>
        /// 3 - invalid file <br></br>
        /// 4 - file is read only<br></br>
        /// </returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        Write_ID3_v1_tag(int number, string filename, int Track,
        string Title, string Artist, string Album, string Year,
        int Genre, string Comment);

        /// <summary>
        /// This function will remove the ID3 tag , if it is available on the file , of course
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="filename">The mp3 file</param>
        /// <returns>0 - no error<br></br>
        /// 1 - unable to remove id3 tag<br></br>
        /// 3 - read only file<br></br></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        Remove_ID3V1_tag(int number, string filename);

        /// <summary>
        /// This function will read the id3 v2 tag , it support id3 v2 tag 2.3.0 and 2.4.0
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="filename">The mp3 file</param>
        /// <param name="Track">Track</param>
        /// <param name="Title">Title</param>
        /// <param name="Artist">Artist</param>
        /// <param name="Album">Album</param>
        /// <param name="Year">Year</param>
        /// <param name="Genre">Genre</param>
        /// <param name="Comment">Comment</param>
        /// <param name="EncodedBy">Encoded by</param>
        /// <param name="URL">URL</param>
        /// <param name="Copyright">Copyright</param>
        /// <param name="OriginalArtist">Original Artist</param>
        /// <param name="Composer">Composer</param>
        /// <returns>0 - no error <br></br>
        /// 1 - no v2 tag on the file<br></br>
        /// 2 - cannot load data from file<br></br>
        /// </returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        Read_ID3_v2_tag(int number, StringBuilder filename, StringBuilder Track, StringBuilder Title, StringBuilder Artist,
        StringBuilder Album, StringBuilder Year, StringBuilder Genre, StringBuilder Comment,
        StringBuilder EncodedBy, StringBuilder URL, StringBuilder Copyright, StringBuilder OriginalArtist
        , StringBuilder Composer);


        /// <summary>
        /// This fuction will write the id3 v2 tag on the file , the format is id3 v2 tag version 2.3.0 ( the same as Winamp )
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="filename">The mp3 file</param>
        /// <param name="Track">Track</param>
        /// <param name="Title">Title</param>
        /// <param name="Artist">Artist</param>
        /// <param name="Album">Album</param>
        /// <param name="Year">Year</param>
        /// <param name="Genre">Genre</param>
        /// <param name="Comment">Comment</param>
        /// <param name="EncodedBy">Encoded by</param>
        /// <param name="URL">URL</param>
        /// <param name="Copyright">Copyright</param>
        /// <param name="OriginalArtist">Original Artist</param>
        /// <param name="Composer">Composer</param>
        /// <returns>0 - no error <br></br>
        /// 1 - read only <br></br>
        /// 2 - unable to create temp file<br></br>
        /// 3 - cannot load data from file<br></br>
        /// 4 - cannot open temp file to write (mode 1)<br></br>
        /// 5 - cannot open input file to read<br></br>
        /// 6 - cannot open temp file to write (mode 2)<br></br>
        /// 7 - cannot replace original file <br></br>
        /// 8 - ? ( I supose tampered id3v2 that may crash due to too large memory requirements )<br></br></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        Write_ID3_v2_tag(int number, string filename, string Track, string Title
        , string Artist, string Album, string Year, string Genre, string Comment
        , string EncodedBy, string URL, string Copyright, string OriginalArtist
        , string Composer);

        /// <summary>
        /// It will remove the ID3 v2 tag from the file , after the removal it will adjust the size of the file
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="filename">The mp3 file</param>
        /// <returns>0 - no error<br></br>
        /// 1 - read only<br></br>
        /// 2 - unable to create temp file<br></br>
        /// 3 - cannot open input file to read<br></br>
        /// 4 - cannot open temp file to write<br></br>
        /// 5 - cannot replace original file<br></br></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        Remove_ID3V2_tag(int number, string filename);

        /// <summary>
        /// It will retrieve the spectrum analizer information
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="f60">60 hertz</param>
        /// <param name="f170">170 hertz</param>
        /// <param name="f310">310 hertz</param>
        /// <param name="f600">600 hertz</param>
        /// <param name="f1000">1000 hertz</param>
        /// <param name="f3000">3000 hertz</param>
        /// <param name="f6000">6000 hertz</param>
        /// <param name="f12000">12 kilohertz</param>
        /// <param name="f14000">14 kilohertz</param>
        /// <param name="f16000">16 kilohertz</param>
        /// <param name="fpeak">Peak value</param>
        /// <returns>Always 0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GetSpectrumAnalyzer(int number, ref int f60, ref int f170, ref int f310, ref int f600
        , ref int f1000, ref int f3000, ref int f6000, ref int f12000, ref int f14000, ref int f16000, ref int fpeak);

        /// <summary>
        /// This function will enable or disable the spectrum analyzer<br></br>
        /// The spectrum analyzer is disabled by default , you need to call the EnableSpectrumAnalyzer to enable it , notice that it will eat 10 to 20 percent of the processor time required to play a mp3 file<br></br>
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="enable">0 will disable, 1 will enable</param>
        /// <returns>Always 0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableSpectrumAnalyzer(int number, int enable);

        /// <summary>
        /// To check whether the path information is a file
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="filename">The file</param>
        /// <returns>0 if path is invalid or folder, 1 if it is a file</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        IsPathFile(int number, string filename);

        /// <summary>
        /// To check whether the path information is a folder
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="filename">The file</param>
        /// <returns>0 if path is invalid or file, 1 if it is a folder</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        IsPathFolder(int number, string filename);

        /*
        /// <summary>
        /// Dont use this function for the moment
        /// </summary>
        /// <param name="number"></param>
        /// <param name="enable"></param>
        /// <param name="window_handle"></param>
        /// <returns></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        RegisterFinishedEventMessage(int number, int enable, int window_handle);

        /// <summary>
        /// It will reset the playlist information on the dll
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <returns>Always 0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        ResetPlaylist(int number);

        /// <summary>
        /// It will add a new item to the playlist , notice that it is number based ,it will not keep the name of the file , just a reference exactly as the number on the listbox or listview , and this number is what will be retrieved later and what will be used internally in the playlist
        /// </summary>
        /// <param name="number"></param>
        /// <returns></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        AddItemToPlaylist(int number);

        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GetNextItemPlaylist(int number);

        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GetShuffleNextItemPlaylist(int number);


        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableRepeatPlaylist(int number, int enable);


        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        SetFilePlayingPlaylist(int number, int index);

        */

        /// <summary>
        /// This function will define what is the size limit of the file that will be read to the memory to play<br></br>
        /// This mean that if the size limit is 300000 and the file size if 250000 , it will read the whole file , load it to the memory and play from the memory<br></br>
        /// In the same way if the file is larger than the limit , it will not load it to the memory but keep the normal way to play the file<br></br>
        /// And notice also that if the old buffer mode is enabled it will not load any file to the memory , this mean that the smart buffer mode need to be enabled to this function has any effect ( the smart buffer mode is enabled by default )<br></br>
        /// So , if the smart buffer mode is enabled , and the file is smaller than the limit , it will play from the memory , if the file is larger it will play in the smart buffer mode way <br></br>
        /// And this function in the initialization start with a file size limit of 250000 bytes , and the min and max limits are 0 and 20000000 bytes<br></br>
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="limit">size in bytes of the file limit</param>
        /// <returns></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        PlayFromMemoryFileSizeLimit(int number, int limit);

        /// <summary>
        /// This function when called will enable the smart buffer mode<br></br>
///<br></br>Notice that this mode is enabled by default , you only need to call this function if you call the function to enable the old buffer mode<br></br>
///<br></br>UseSmartFileBufferMode will make the control to preread information
///in the file before the decoding or playback of the file , then in case of latencies
///it will first load 10 to 20 seconds of the playback then it will play , it
///also will try to read the next 10 seconds chunk from the file when half of the
///first buffer is used , then when the first buffer is empty the second buffer is
///already filled with the next chunk , it also can avoid interruption of the
///playback , but notice that if the latency is too large , it will stop the playback
///until the next 10 seconds of the playback is available , this will make the control
///play at least ten seconds before interruption for buffering
///<br></br>It is the default mode now , then no need to call this function in the
///initialization of the control
///<br></br>Notice also that the new DebugInformation event will always inform what kind of
///buffer method it is using , it will be the old mode or the new smart mode or the
///file loaded to the memory mode<br></br>
///<br></br>What is new in the release 2.6.2  :  Fixed a
///bug in the smart buffer method , the version
///2.5.8 may show an assert message box about an
///error in the file filebuffer.c at line 595 or
///line 790 with a "assert (bytesleft >= 0)" information
///, this error occurs if the size of the file
///change while it is playing , to reproduce the
///problem load a small mp3 file , start the playback
///and while it is playing bring up the id3 tag
///form and add or remove the id3 v1 or v2 tag ,
///and wait for the end of the playback , in the
///end of the playback you will see the error
///assert message box , this problem is fixed
///in the version *.*.* and above , notice that anyway the chances
///of a file size change during playback is very
///small<br></br>
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <returns>0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        UseSmartFileBufferMode(int number);

        /// <summary>
        /// This function will enable the old buffer mode , this mean the method used prior to the version *.*.*<br></br>
        /// UseOldFileBufferMode will make the control work exactly as the previous versions<br></br>
        /// It will load portions of the file as it is requested<br></br>
        /// It is subject to delays and playback interruption in case of file access latencies in
        ///networks , or some kind of slow drives<br></br>
        ///Use it only if you really have an unknown reason to don't use the new smart mode, that indeed , is enabled by default<br></br>
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <returns>0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        UseOldFileBufferMode(int number);



        public static int playerselection = 1;



        /// <summary>
        /// It will retrieve the internal debug information, things like buffer size and mp3 decoder errors
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="debug">where the data arrives</param>
        /// <returns>0 if it has data or more to come, 1 if no data is available</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        DebugInformation(int number, StringBuilder debug);

        /*
         * 
         * unable to test due to a no delay drive installed at this moment
         * 
        /// <summary>
        /// 
        /// </summary>
        /// <param name="number"></param>
        /// <returns></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        Bufferizing(int number);
        */

        /// <summary>
        /// It will enable or disable the voice removal wave effect<br></br>
///It is disabled by default<br></br>
///The voice removal code will try to remove information from the
///samples based on what is the same in both channels<br></br>
///Then if the same information is available in both channels
///it will be just removed , and the remaining information
///is only the information that are different in both channels<br></br>
///Since the voice is equal in both channels  in any normal stereo file
///it will just disappear after passing this filter<br></br>
///Notice that a mono file will just become pure silence
///since both channels will be canceled<br></br>
///The capacity of this code to work will depend on the
///file , then it is not a 100 percent working solution<br></br>
///Several new wave effects will be added to future releases<br></br>
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="enable">0 will disable, 1 will believe or not enable</param>
        /// <returns>nothing but 0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableVoiceRemoval(int number, int enable);

        /// <summary>
        /// The EnableEcho function wil enable or disable the echo<br></br>
///The argument Delay range from 0 to 100 , 0 means 1
///second of delay of the echo , 100 means no delay at
///all , then it means no echo<br></br>
///It initiate at 50<br></br>
///This echo effect will copy portions of the file already
///played in a buffer that later is added again to the next chunk
///to play , giving an echo effect<br></br>
///It can be used also to generate a reverberation effect, just
///adjust the value of the Delay argument<br></br>
///The Enable argument will define whether the echo effect is
///enabled or not<br></br>
///Several new wave effects will be added to future releases<br></br>
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="enable">it will enable with a 1 or disable with a 0</param>
        /// <param name="delay">the delay value</param>
        /// <returns>0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableEcho(int number, int enable, int delay);

        //more to come son

        /// <summary>
        /// The PitchControl will change the playback speed
///of the player<br></br>
///It means that the playback will be faster or slower<br></br>
///It range from 0 to 100 , and initiate at 50<br></br>
///50 means no speed change<br></br>
///More close to 0 and it slow down the playback<br></br>
///More close to 100 and it become faster<br></br>
///The Control argument is where the speed is defined<br></br>
///The Enable argument will enable or disable this
///effect<br></br>
///Several new wave effects will be added to future releases, I supose<br></br>
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="enable">0 to no, 1 to yes</param>
        /// <param name="control">the value to pass</param>
        /// <returns></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        PitchControl(int number, int enable, int control);

        /// <summary>
        /// This function will enable or disable a surround like wave effect in the playback, requires a soundcard and fones de ouvido
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="enable">0 to no or 1</param>
        /// <returns></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableSurround(int number, int enable);

        /// <summary>
        /// This function will enable or disable a surround like wave effect in the playback , the range argument range from 0 to 100, requires a soundcard and fones de ouvido
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="enable">0 to no or 1</param>
        /// <param name="range">the range</param>
        /// <returns></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableSurround2(int number, int enable, int range);

        /// <summary>
        /// It will handle VBR files as CBR files , it is usefull to play correctly some playback streams, search for VBR and CBR on Google or Wikipedia
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="enable">1 to yes or 0</param>
        /// <returns></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        DisableVBR(int number, int enable);

        /// <summary>
        /// It will enable or disable the playback of encrypted files , the password will define the password to be used , in order to play the file it need to be encrypted with the function Encrypt_File
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="enable">0 to no or 1</param>
        /// <param name="pass">the password</param>
        /// <returns>0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        UseEncryption(int number, int enable, string pass);

        /// <summary>
        /// It will encrypt the file in order to be played by the control , to play it you need to use the function UseEncryption<br></br>
///In order to unencrypt the file just encrypt it again with the same password , it is RC4, yes it is weak but works, AES CTR will be used later<br></br>
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="input">input file</param>
        /// <param name="output">output file</param>
        /// <param name="pass">password</param>
        /// <returns>0 ? bug here, will be fixed in the next release</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        Encrypt_File(int number, string input, string output, string pass);

        /// <summary>
        /// It will define whether the stream will be saved to the disk, the path define the place where it will be saved
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="enable">0 to no or 1</param>
        /// <param name="path">the valid path</param>
        /// <returns>0 ? bug here, need to validate the path at least</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        SaveStreamingFile(int number, int enable, string path);

        /// <summary>
        /// It will set the playback buffer , a value of 0 will disable the buffer and just play what is read , a value of 5000 will read first 5 milliseconds of data before playing , min 0 max 30000
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="value">the value</param>
        /// <returns>0 ?</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        SetStreamingBuffer(int number, int value);
        /*
        /// <summary>
        /// It will select whether you will use mpeglib or madlib to decode the MP3 file, by default it is madlib, people say that madlib is better but I only know very well mpeglib, if you are in doubt use mpeglib
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="decoder">0 to mpeglib or any other value to madlib, 1 by default</param>
        /// <returns>0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        SelectMP3Decoder(int number, int decoder);
        */
        /// <summary>
        /// It will enable or disable the Freeverb, Freeverb is a very good reverberation, ffdshow has it also and also setttings to modify it, we dont have this option yet
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="enable">0 to no or 1</param>
        /// <returns>0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableFreeverb(int number, int enable);

        /// <summary>
        /// It will enable SoundTouch , then you can change the tempo, pitch and rate, the quality of this code is amazing only testing you will see the very good precision, the original developer of SoundTouch know what he is doing
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="enable">0 to no or 1</param>
        /// <param name="tempo">range from -95 to +95</param>
        /// <param name="pitch">range from -60 to +60</param>
        /// <param name="rate">range from -95 to +95</param>
        /// <returns></returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        EnableSoundTouch(int number, int enable, int tempo, int pitch, int rate);

        /// <summary>
        /// It will retrieve information from a standard and old ini file that is in your temp folder on RSPSoftware
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="key">the key</param>
        /// <param name="data">the data</param>
        /// <param name="defaulT">default value, must be from my point of view ""</param>
        /// <returns>0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GetSettings(int number, string key, StringBuilder data, string defaulT);

        /// <summary>
        /// It will save information in a standard and old ini file that is in your temp folder on RSPSoftware
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="key">the key</param>
        /// <param name="data">the data</param>
        /// <returns>0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        SaveSettings(int number, string key, string data);

        /// <summary>
        /// to show um aboutbox of the dll, very simple
        /// </summary>
        /// <returns>0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        About();

        /// <summary>
        /// To return the information and version number of the win32 dll
        /// </summary>
        /// <param name="data">the data</param>
        /// <returns>0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        ControlName(StringBuilder data);

        /// <summary>
        /// It will retrieve the number of wave out devices ( soundcards ) you have installed in the system<br></br>
        /// Notice that a value of 0 means that you don't have an installed soundcard , so , you cannot play using this control<br></br>
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <returns>the number of wave out devices</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GetNumberofWaveOutDevices(int number);

        /*
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        Enter_License(string name, string code);
        */

        /// <summary>
        /// It will receive a string with the description of the error passed
        /// </summary>
        /// <param name="number">The player selector , for each different player a different number need to be used, but for a single player mode just always pass 1</param>
        /// <param name="value">the error</param>
        /// <param name="data">the string</param>
        /// <returns>0</returns>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        GetErrorString(int number, int value, StringBuilder data);

        /// <summary>
        /// It will retrieve the remaining time of the playback
        /// , it can be useful
        /// </summary>
        [DllImport("rspmp3ocx1.dll")]
        public static extern int
        Alladin_GetRemainingTime(int number, StringBuilder data);

        [DllImport("rspmp3ocx1.dll")]
        extern static IntPtr utf8towide(string utf8_filename);

        public static string utf82wide(string utf8_filename)
        {
            IntPtr retVal = utf8towide(utf8_filename);

            string val = Marshal.PtrToStringUni (retVal);
            return val;
        }

        [DllImport("rspmp3ocx1.dll", CharSet = CharSet.Unicode)]
        extern static IntPtr widetoutf8(string unicode_filename);

        public static string wide2utf8(string unicode_filename)
        {
            IntPtr retVal = widetoutf8(unicode_filename);

            string val = Marshal.PtrToStringAnsi(retVal);
            return val;
        }

    }
}
